% CIS601 - Tom Gradel - Homework 3

for image_no = 1:2
    if (image_no == 1)
        filename = 'noise_1.gif';
    else
        filename = 'noise_2.gif';
    end
    I = imread(filename);

    % create smoothing filter
    f = ones(3) ./ 9;
    FI = filter2(f,double(I));

    figure, imshow(I);title(['original ' filename]);
    figure, imshow(uint8(FI)); title(['smoothed ' filename]);

    % pad array
    [row,col]=size(I);
    ipad = [I(1,:); I; I(row,:)];
    ipad = [ipad(:,1) ipad ipad(:,col)];

    % create median filter
    im_median = zeros(row,col);
    im_dilation = zeros(row,col);
    im_erosion = zeros(row,col);
    for r = 1:row
        for c = 1:col
            m = double(ipad([r+1 r+2],[c+1 c+2]));
            im_median(r,c) = median(m(:)');
            im_dilation(r,c) = max(m(:)'); % dilation filter = max
            im_erosion(r,c) = min(m(:)');  % erosion filter = min
        end
    end
    figure, imshow(uint8(im_median)); title(['median ' filename]);
    figure, imshow(uint8(im_dilation)); title(['dilation ' filename]);
    figure, imshow(uint8(im_erosion)); title(['erosion ' filename]);

    % create opening filter = dilation o erosion
    ipad = [im_erosion(1,:); im_erosion; im_erosion(row,:)];
    ipad = [ipad(:,1) ipad ipad(:,col)];

    im_opening = zeros(row,col);
    for r = 1:row
        for c = 1:col
            m = double(ipad([r+1 r+2],[c+1 c+2]));
            im_opening(r,c) = max(m(:)');
        end
    end
    figure, imshow(uint8(im_opening)); title(['opening ' filename]);

    % create closing filter = erosion o dilation
    ipad = [im_dilation(1,:); im_dilation; im_dilation(row,:)];
    ipad = [ipad(:,1) ipad ipad(:,col)];

    im_closing = zeros(row,col);
    for r = 1:row
        for c = 1:col
            m = double(ipad([r+1 r+2],[c+1 c+2]));
            im_closing(r,c) = min(m(:)');
        end
    end
    figure, imshow(uint8(im_closing)); title(['closing ' filename]);
end

